<template>
  <rui-form :errors="errors"
            model="element"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field input-id="element_name" :label="$t('activerecord.attributes.element.name')">
      <input id="element_name" v-model="inputs.name" type="text">
    </rui-field>

    <rui-field input-id="element_resource" :label="$t('activerecord.attributes.element.resource')">
      <multiselect id="element_resource"
                   v-model="resource"
                   :options="resources"
                   :allow-empty="false"
                   track-by="id"
                   :custom-label="(r) => `${r.name} - ${r.latinName}`" />
    </rui-field>

    <rui-field v-if="!element.patchId" input-id="element_layer" :label="$t('activerecord.attributes.element.layer')">
      <select id="element_layer" v-model="inputs.layerId">
        <option v-for="layer in layers" :key="layer.id" :value="layer.id">{{ layer.name }}</option>
      </select>
    </rui-field>

    <rui-field v-if="element.patchId" input-id="element_patch" :label="$t('activerecord.attributes.element.patch')">
      <multiselect id="element_patch"
                   v-model="patch"
                   :options="patches"
                   :allow-empty="false"
                   track-by="id"
                   label="displayName" />
    </rui-field>

    <rui-field v-if="!element.patchId" input-id="element_diameter" :label="$t('activerecord.attributes.element.diameter')" append="m">
      <input v-model="inputs.diameter" type="number" min="0" step="0.01">
    </rui-field>

    <template v-if="element.implantationPlannedFor || element.implantedAt">
      <rui-date-time-picker v-model="inputs.implantation.value"
                            :time="false"
                            :input-id="`${formId}-implant`"
                            :label="$t(`activerecord.attributes.element.${inputs.implantation.field}`)"
                            :popup="true"
                            :not-after="inputs.implantation.notAfter"
                            input-name="element_implantation_field"
                            required />
      <div class="rui-field">
        <strong>{{ $t('activerecord.attributes.element.implantation_mode') }}</strong>
        <label v-for="mode in modes" :key="mode">
          <input v-model="inputs.implantationMode" type="radio" name="implantation_mode" :value="mode">
          {{ $t(`activerecord.attributes.element/implantation_mode.${mode}`) }}
        </label>
      </div>
    </template>

    <rui-date-time-picker v-if="element.removalPlannedFor || element.removedAt"
                          v-model="inputs.removal.value"
                          :time="false"
                          :input-id="`${formId}-remove`"
                          :label="$t(`activerecord.attributes.element.${inputs.removal.field}`)"
                          :popup="true"
                          :not-before="inputs.removal.notBefore"
                          input-name="element_removal_field"
                          required />
  </rui-form>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'

import { ELEMENT_IMPLANTATION_MODES } from '../../../../../helpers/constants.js'
import Multiselect from 'vue-multiselect'
import Element from '../../../../classes/models/Element'
import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'

export default {
  name: 'GpaElementForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiDateTimePicker, RuiField, RuiForm, Multiselect },
  props: {
    element: { type: Element, required: true },
  },
  data () {
    return {
      loading: false,
      inputs: { ...this.resetInputs() },
      errors: null,
      formId: randomString(),
      showPicker: false,
      // Other fields values for vue-multiselect
      resource: this.initializeResource(),
      patch: this.initializePatch(),
      modes: ELEMENT_IMPLANTATION_MODES,
    }
  },
  computed: {
    resources () { return this.$store.getters.resources },
    patches () { return this.$store.getters.patches },
    layers () { return this.$store.getters.layers },
  },
  methods: {
    resetInputs () {
      const state = {
        id: this.element.id,
        name: this.element.name,
        diameter: this.element.diameter,
        resourceId: this.element.resourceId,
        implantation: { notAfter: null, notBefore: null },
        removal: { notAfter: null, notBefore: null },
        implantationMode: this.element.implantationMode,
        layerId: this.element.layerId,
      }

      if (this.element.implantedAt) {
        state.implantation = {
          field: 'implanted_at',
          value: this.element.implantedAt || null,
          notAfter: this.element.removedAt || null,
        }
      } else {
        state.implantation = {
          field: 'implantation_planned_for',
          value: this.element.implantationPlannedFor || null,
        }
      }

      if (this.element.removedAt) {
        state.removal = {
          field: 'removed_at',
          value: this.element.removedAt || null,
          notBefore: this.element.implantedAt || null,
        }
      } else {
        state.removal = {
          field: 'removal_planned_for',
          value: this.element.removalPlannedFor || null,
          notBefore: this.element.implantedAt || null,
        }
      }

      return state
    },
    initializeResource () {
      const resource = this.$store.getters.resource(this.element.resourceId)
      return { id: resource.id, name: resource.name, latinName: resource.latinName }
    },
    initializePatch () {
      if (this.$props.element.patchId) {
        const patch = this.$store.getters.patch(this.element.patchId)
        return { id: patch.id, displayName: patch.displayName }
      }

      return null
    },
    save () {
      this.loading = true
      const payload = {
        id: this.element.id,
        name: this.inputs.name,
        diameter: this.inputs.diameter,
        resource_id: this.resource.id,
        patch_id: this.patch ? this.patch.id : null,
        layer_id: this.inputs.layerId,
        implantation_mode: this.inputs.implantationMode,
      }
      payload[this.inputs.implantation.field] = this.inputs.implantation.value
      payload[this.inputs.removal.field] = this.inputs.removal.value

      this.$store.dispatch('updateElement', payload)
        .then(() => { this.$emit('saved', this.element) })
        .catch((errors) => { this.errors = errors })
        .then(() => { this.loading = false })
    },
  },
}
</script>
